package csc8711.nosql;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import nl.renarj.jasdb.api.SimpleEntity;
import nl.renarj.jasdb.api.query.QueryResult;
import nl.renarj.jasdb.core.exceptions.*;

//import nl.renarj.jasdb.core.*;


public class NoSQLService extends HttpServlet {

	/**
	 * 
	 */
	JasDbConnection jasdb = null;
	Message msgBean =null;
	HttpSession mySession = null;
	InventoryBean inventories = null;
	CategoryBean categories = null;
	UserBean users = null;
	private static final long serialVersionUID = 1L;

	public void doGet(HttpServletRequest request, HttpServletResponse response)
		    throws ServletException, IOException {
		doPost(request, response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
		    throws ServletException, IOException {
		PrintWriter out = response.getWriter();
		response.setContentType("text/html");
		mySession = request.getSession(false);	
		inventories = new InventoryBean();
		categories = new CategoryBean();
		users = new UserBean();
		msgBean = new Message();
		try {
			jasdb = new JasDbConnection();
			if (request.getParameterMap().containsKey("action")) {
				String action = request.getParameter("action");
				if(action.equals("login")) {
						String userid = request.getParameter("userid");
						String password = request.getParameter("password");
						if(userid.equals("") || password.equals("")) {
							throw new JasDbException("User or Password is blank");
						}
					
						if (!jasdb.findUser(userid, password)) throw new JasDbException("User not found");
						mySession.setAttribute("userid",userid);
						Cookie userCookie = new Cookie("userid",userid);
						userCookie.setMaxAge(3600);
						response.addCookie(userCookie);
						Cookie passCookie = new Cookie("password",password);
						passCookie.setMaxAge(3600);
						response.addCookie(passCookie);
						refreshCategories();
						if(jasdb.isEmpty("inventory")) {
						
							if (jasdb.isEmpty("category")) {
								throw new JasDbException("Category is empty. <a href=\"newCategory.jsp\">Add new category</a>");
							} else {
								throw new JasDbException("Inventory is empty. <a href=\"newInventory.jsp\">Add new inventory</a>");
								
							}
						} else {
							refreshUsers();
							refreshInventories();
							RequestDispatcher rd = request.getRequestDispatcher("inventory.jsp");
							rd.forward(request, response);
						}
				} else if(action.equals("addCategory")) {
					String category = request.getParameter("category");
					String description = request.getParameter("description");
					jasdb.addCategory(category, description);
					refreshCategories();
					RequestDispatcher rd = request.getRequestDispatcher("inventory.jsp");
					rd.forward(request, response);
				} else if(action.equals("viewCategory")) {
					String id,category,description=null;
					QueryResult result = jasdb.viewCategory();
					out.println("<html xmlns = \"http://www.w3.org/1999/xhtml\">");
					out.println("<head><title>CSC8711-Project 4</title><link rel=\"stylesheet\" href=\"css/style.css\" type=\"text/css\"/>");
					out.println("</head><body>");  
					if(result.size()==0) {
							out.println("<center><b>No Category</b><br/>");
							out.println("<a href=\"newCategory.jsp\">Add new Category</a>");
					} else {
						out.println("<center>");
						out.println("<h3>Category table</h3>");
						out.println("<table border=1>");
						out.println("<tr bgcolor='yellow'><th>Name</th><th>Description</th><th>Edit/Delete</th></tr>");
						for(SimpleEntity entity : result) {	
							 id = entity.getValue("__ID").toString();
							 if(entity.hasProperty("category"))
								   category = entity.getValue("category").toString();
							   else
								   category = "null";
							   if( entity.hasProperty("description")) 
								   description = entity.getValue("description").toString();
							   else
								   description = "null";
							   out.println("<tr><td>"+category+"</td><td>"+description+"</td>");
							   out.println("<td><a href=updateCategory.jsp?id="+id+"&category="+category+"&description="+description+">Edit</a>/"+
									   		"<a href=NoSQLService?action=removeCategory&id="+id+">Delete</a></td>");
							   out.println("</tr>");
					   } 
						out.println("</table>");
						out.println("<br/><a href=newCategory.jsp>Add new category</a>/<a href=inventory.jsp>View inventory</a>");
						out.println("<br/><form id=\"logout\" action=\"NoSQLService\" method = \"post\">");
						out.println("<input type=\"submit\" name=\"action\" class=\"btnMouseOut\" value=\"logout\" onmouseover=\"this.className='btnMouseOver'\" onmouseout=\"this.className='btnMouseOut'\"/><br/>");
						out.println("</form>");
						out.println("</body></html>");
					}
					
				} else if(action.equals("removeCategory")) {
					String id = request.getParameter("id");
					if(jasdb.inventoryByCategory(id)) {
						jasdb.removeCategory(id);
						refreshCategories();
						RequestDispatcher rd = request.getRequestDispatcher("inventory.jsp");
						rd.forward(request, response);					
					} else {
						throw new JasDbException("Unable to delete category. Remove all inventory belongs to this category");
					}

				} else if(action.equals("updateCategory")) {
					String id = request.getParameter("id");
					String description = request.getParameter("description");
					String category = request.getParameter("category");
					//String categoryID = jasdb.getCategoryID(category);
					jasdb.updateCategory(id,category, description);
					refreshCategories();
					RequestDispatcher rd = request.getRequestDispatcher("inventory.jsp");
					rd.forward(request, response);
				} else if(action.equals("addInventory")) {
					String name = request.getParameter("name");
					String desc = request.getParameter("description");
					String cat = request.getParameter("category");
					String price = request.getParameter("price");
					String count = request.getParameter("count");
					jasdb.addInventory(name,desc,cat,price,count);
					refreshInventories();
					RequestDispatcher rd = request.getRequestDispatcher("inventory.jsp");
					rd.forward(request, response);
				} else if(action.equals("removeInventory")) {
					String id = request.getParameter("id");
					jasdb.removeInventory(id);
					refreshInventories();
					RequestDispatcher rd = request.getRequestDispatcher("inventory.jsp");
					rd.forward(request, response);
				} else if (action.equals("updateInventory")) {
					String id = request.getParameter("id");
					String name = request.getParameter("name");
					String desc = request.getParameter("description");
					String category = request.getParameter("category");
					String price = request.getParameter("price");
					String count = request.getParameter("count");
					String categoryID = jasdb.getCategoryID(category);
					jasdb.updateInventory(id,name,desc,categoryID,price,count);
					refreshInventories();
					RequestDispatcher rd = request.getRequestDispatcher("inventory.jsp");
					rd.forward(request, response);
				} else if (action.equals("cancel")) {
					RequestDispatcher rd = request.getRequestDispatcher("inventory.jsp");
					rd.forward(request, response);
				} else if (action.equals("addUser")) {
					String userid = request.getParameter("userid");
					String password = request.getParameter("password");
					String name = request.getParameter("name");
					String role = request.getParameter("role");
					jasdb.addUser(userid,password,name,role);
					refreshUsers();
					RequestDispatcher rd = request.getRequestDispatcher("user.jsp");
					rd.forward(request, response);
				} else if (action.equals("removeUser")) {
					String id = request.getParameter("id");
					jasdb.removeUser(id);
					refreshUsers();
					RequestDispatcher rd = request.getRequestDispatcher("user.jsp");
					rd.forward(request, response);
				} else if (action.equals("updateUser")) {
					String id = request.getParameter("id");
					String userid = request.getParameter("userid");
					String password = request.getParameter("password");
					String name = request.getParameter("name");
					String role = request.getParameter("role");
					jasdb.updateUser(id,userid,name,password,role);
					refreshUsers();
					RequestDispatcher rd = request.getRequestDispatcher("user.jsp");
					rd.forward(request, response);
				} else if (action.equals("logout")) {
					logout();
					RequestDispatcher rd = request.getRequestDispatcher("index.jsp");
					rd.forward(request, response);
				} else if (action.equals("searchByName")) {
					String q = request.getParameter("name");
					InventoryBean inventoryBean = (InventoryBean)mySession.getAttribute("inventories");
					InventoryItem[] items = inventoryBean.getInventories();
					String hint = "";
					String tmp = "";
					if (q.length()>0) {
						for(int i=0;i<items.length;i++) {
							tmp = items[i].getName().toLowerCase();
							if(tmp.toLowerCase().contains(q)) {
							if(hint.equals("")) {
								hint="<br/><table class=\"main\">";
								hint= hint.concat("<tr><th>Name</th><th>Category</th><th>Price</th><th>Count</th><th>Edit/Delete</th></tr>");
								hint= hint.concat("<tr>");
								hint= hint.concat("<td>"+items[i].getName()+"</td>");
								hint= hint.concat("<td>"+items[i].getCategory()+"</td>");
								hint= hint.concat("<td class='price'>$"+items[i].getPrice()+"</td>");
								hint= hint.concat("<td class='center'>"+items[i].getCount()+"</td>");
								hint= hint.concat("<td class='center'><a href=\"updateInventory.jsp?id="+items[i].getId()+"&name="+items[i].getName()+"&description="+items[i].getDescription()+"&category="+items[i].getCategory()+"&price="+items[i].getPrice()+"&count="+items[i].getCount()+"\">Edit</a>"+
										"/<a href=\"NoSQLService?action=removeInventory&id="+items[i].getId()+"\">Delete</a></td>");
								hint=hint.concat("</tr>");
							} else {
								hint= hint.concat("<tr>");
								hint= hint.concat("<td>"+items[i].getName()+"</td>");
								hint= hint.concat("<td>"+items[i].getCategory()+"</td>");
								hint= hint.concat("<td class='price'>$"+items[i].getPrice()+"</td>");
								hint= hint.concat("<td class='center'>"+items[i].getCount()+"</td>");
								hint= hint.concat("<td class='center'><a href=\"updateInventory.jsp?id="+items[i].getId()+"&name="+items[i].getName()+"&description="+items[i].getDescription()+"&category="+items[i].getCategory()+"&price="+items[i].getPrice()+"&count="+items[i].getCount()+"\">Edit</a>"+
										"/<a href=\"NoSQLService?action=removeInventory&id="+items[i].getId()+"\">Delete</a></td>");
								hint=hint.concat("</tr>");
								}
							}
						}
						if (hint.equals("")) {
							hint="<b><font color=red>No match</font></b>";
							hint= hint.concat("<br/><a href=\"newInventory.jsp\">Add new Inventory</a>/<a href=\"NoSQLService?action=viewCategory\">View Category</a>");
						} else {
							hint= hint.concat("</table>");
							hint= hint.concat("<br/><a href=\"newInventory.jsp\">Add new Inventory</a>/<a href=\"NoSQLService?action=viewCategory\">View Category</a>");
						}
						// get the communication channel with the requesting client
						out.println(hint);
					}
					
				} else if (action.equals("searchByCategory")) {
					String t = request.getParameter("category");
					InventoryBean inventoryBean = (InventoryBean)mySession.getAttribute("inventories");
					InventoryItem[] items = inventoryBean.getInventories();
					String hint = "";
					for(int i=0;i<items.length;i++) {
						if(t.equals(items[i].getCategory())) {
							if(hint.equals("")) {
								hint="<br/><table border='1'>";
								hint= hint.concat("<tr><th>Name</th><th>Category</th><th>Price</th><th>Count</th><th>Edit/Delete</th></tr>");
								hint= hint.concat("<tr>");
								hint= hint.concat("<td>"+items[i].getName()+"</td>");
								hint= hint.concat("<td>"+items[i].getCategory()+"</td>");
								hint= hint.concat("<td class='price'>$"+items[i].getPrice()+"</td>");
								hint= hint.concat("<td class='center'>"+items[i].getCount()+"</td>");
								hint= hint.concat("<td class='center'><a href=\"updateInventory.jsp?id="+items[i].getId()+"&name="+items[i].getName()+"&description="+items[i].getDescription()+"&category="+items[i].getCategory()+"&price="+items[i].getPrice()+"&count="+items[i].getCount()+"\">Edit</a>"+
												"/<a href=\"NoSQLService?action=removeInventory&id="+items[i].getId()+"\">Delete</a></td>");

								hint=hint.concat("</tr>");
								} else {
								hint= hint.concat("<tr>");
								hint= hint.concat("<td>"+items[i].getName()+"</td>");
								hint= hint.concat("<td>"+items[i].getCategory()+"</td>");
								hint= hint.concat("<td class='price'>$"+items[i].getPrice()+"</td>");
								hint= hint.concat("<td class='center'>"+items[i].getCount()+"</td>");
								hint= hint.concat("<td class='center'><a href=\"updateInventory.jsp?id="+items[i].getId()+"&name="+items[i].getName()+"&description="+items[i].getDescription()+"&category="+items[i].getCategory()+"&price="+items[i].getPrice()+"&count="+items[i].getCount()+"\">Edit</a>"+
										"/<a href=\"NoSQLService?action=removeInventory&id="+items[i].getId()+"\">Delete</a></td>");
								hint=hint.concat("</tr>");
								}
							}
					} // end for loop
					if (hint.equals("")) {
						hint="<b><font color=red>No match</font></b>";
						hint= hint.concat("<br/><a href=\"newInventory.jsp\">Add new Inventory</a>/<a href=\"NoSQLService?action=viewCategory\">View Category</a>");
					} else {
						hint = hint.concat("</table>");
						hint = hint.concat("<br/><a href=\"newInventory.jsp\">Add new Inventory</a>/<a href=\"NoSQLService?action=viewCategory\">View Category</a>");
					}
					// get the communication channel with the requesting client
					out.println(hint);
				} else {
					throw new JasDbException("action not support");
				}
 		   
			} else {
				throw new JasDbException("action parameter is missing.");
 			}
		} catch (JasDbException e) {
			msgBean.setMessage(e.getMessage());
			mySession.setAttribute("message",msgBean);
			RequestDispatcher rd = request.getRequestDispatcher("displayMessage.jsp");
			rd.forward(request, response);
		} catch (Exception e) {
			msgBean.setMessage(e.getMessage());
			mySession.setAttribute("message",msgBean);
			RequestDispatcher rd = request.getRequestDispatcher("displayMessage.jsp");
			rd.forward(request, response);
		}
	}//End of doPost
	private void refreshInventories() throws JasDbException, JasDBStorageException {
		inventories.setInventories(jasdb.getInventory());	
		mySession.setAttribute("inventories",inventories);
	}
	private void refreshCategories() throws JasDbException, JasDBStorageException {
		categories.setCategories(jasdb.getCategory());
		mySession.setAttribute("categories",categories);
	}
	private void refreshUsers() throws JasDbException, JasDBStorageException {
		users.setUsers(jasdb.getUsers());
		mySession.setAttribute("users",users);
	}
	private void logout() {
		jasdb = null;
		categories = null;
		inventories = null;	
		mySession.invalidate();
	}
}//End of class Definition