<%@ page import="csc8711.nosql.*" %>


<jsp:useBean id="categories" type="csc8711.nosql.CategoryBean" scope="session">
	<jsp:setProperty name="categories" property="*" />
</jsp:useBean>

<jsp:useBean id="inventories" type="csc8711.nosql.InventoryBean" scope="session">
	<jsp:setProperty name="inventories" property="*" />
</jsp:useBean>

<%
	String message = "Inventory";
	HttpSession mySession = request.getSession(false);
	CategoryItem[] catItems = categories.getCategories();
	InventoryItem[] items = inventories.getInventories();
%>
<html>
	<head>
		<link rel="stylesheet" href="css/style.css" type="text/css"/>
	</head>
	<body>
	<script type="text/javascript">
	function showInventory(str) {
		document.getElementById("searchByCategory").value="No category selected";
		if (str.length==0) { 
  		document.getElementById("txtHint").innerHTML="";
  		return;
 	 	}
		xmlhttp= getXMLHttp();
		xmlhttp.onreadystatechange=function() {
  		if (xmlhttp.readyState==4 && xmlhttp.status==200) {
    		document.getElementById("txtHint").innerHTML=xmlhttp.responseText;
    	}
  	}
		xmlhttp.open("GET","NoSQLService?action=searchByName&name="+str,true);
		xmlhttp.send();
}
function showCategory(str) {
		document.getElementById("searchByName").value="";
		if (str=="No category selected") { 
  		document.getElementById("txtHint").innerHTML="";
  		return;
 	 	}
		xmlhttp= getXMLHttp();
		xmlhttp.onreadystatechange=function() {
  		if (xmlhttp.readyState==4 && xmlhttp.status==200) {
    		document.getElementById("txtHint").innerHTML=xmlhttp.responseText;
    	}
  	}
		xmlhttp.open("GET","NoSQLService?action=searchByCategory&category="+str,true);
		xmlhttp.send();
}
function getXMLHttp () {
		if (window.XMLHttpRequest) {// code for IE7+, Firefox, Chrome, Opera, Safari
  		xmlhttp=new XMLHttpRequest();
  	} else {// code for IE6, IE5
  		xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
  	}
  	return xmlhttp
}
     </script>
		<%if (items.length==0) {%>
			<h3> <%= mySession.getAttribute("userid").toString()%> have no <%= message%></h3> <br/>
			<a href="newInventory.jsp">Add new Inventory</a>
		<% } else {%>
		<center>
		<h3><%= mySession.getAttribute("userid").toString()%> <%= message%></h3> <br/>
				<h4>Search by Name: <input id="searchByName" type="text" id="txt1" onkeyup="showInventory(this.value)" />&nbsp;
					 Or by Category: <select id="searchByCategory" onchange="showCategory(this.value)">
					 	<option value ="No category selected">No category selected</option>
					 <% for (int i=0;i<catItems.length;i++) { %>
					 	 <option value = "<%= catItems[i].getCategory() %>"><%= catItems[i].getCategory() %></option>
					 <% } %>
					</select>
					<br/>
					<p><% mySession.getAttribute("userid").toString();%> Inventory: <span id="txtHint"><br/><br/>
						<table class="main">
							<tr>
								<th>Name</th>
								<th>Category</th>
								<th>Price</th>
								<th>Count</th>
								<th>Edit/Delete</th>
							</tr>
							<% for (int i=0;i<items.length;i++) { %>
								<%if (i%2==0) {%>
									<tr class="even">
								<% } else {%>
									<tr class="odd">
								<% } %>
									<td><%= items[i].getName() %></td>
									<td><%= items[i].getCategory() %></td>
									<td class="price">$<%= items[i].getPrice() %></td>
									<td class="center">
										<% if (items[i].getCount().equals("0")) { %>
											<span class="zero" id="count<%= i%>"><%= items[i].getCount() %></span>
										<% } else {%>
											 <span id="count<%= i %>"><%= items[i].getCount() %></span>
										<% } %>
									</td>
									<td class="center">
										<a href="updateInventory.jsp?id=<%= items[i].getId() %>&name=<%= items[i].getName() %>&description=<%= items[i].getDescription() %>&category=<%= items[i].getCategory() %>&price=<%= items[i].getPrice() %>&count=<%= items[i].getCount() %>">Edit</a>/<a href="NoSQLService?action=removeInventory&id=<%= items[i].getId() %>">Delete</a>
									</td>
								</tr>
							<% } %>
						</table>
						<br/><a href="newInventory.jsp">Add new Inventory</a>/<a href="NoSQLService?action=viewCategory">View Category</a>/<a href="user.jsp">User Management</a>
					</span></p></h4>
					<form id="logout" action="NoSQLService" method = "post">
						<input type="submit" name="action" class="btnMouseOut" value="logout" onmouseover="this.className='btnMouseOver'" onmouseout="this.className='btnMouseOut'"/><br/>
				</form>
		</center>
		<% } %>
	</body>
</html>